-- First check class so we can stop loading otherwise
local SmartResSpell = {
	PRIEST = "Resurrection",
	SHAMAN = "Ancestral Spirit",
	PALADIN = "Redemption"
}

local _,class = UnitClass("player")
if not SmartResSpell[class] then return end

-- Initialize libraries
SmartRes = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "AceHook-2.1", "CandyBar-2.0", "FuBarPlugin-2.0")
local L =  AceLibrary("AceLocale-2.2"):new("SmartRes")
local BS = AceLibrary("Babble-Spell-2.2")
local DD = AceLibrary("Dewdrop-2.0")
local SM = AceLibrary("SharedMedia-1.0")
local P =  AceLibrary("PaintChips-2.0")

-- Localization
L:RegisterTranslations("enUS", function() return {
	["Key Binding"] = true,
	["Key Binding for resurrection."] = true,
	["Anchor"] = true,
	["Show a dragable anchor."] = true,
	["Resurrection Bars"] = true,
	["Options for resurrection statusbar."] = true,
	["Bar Texture"] = true,
	["Change the texture of the timer bars."] = true, 
	["Bar Color"] = true, 
	["Set the default bar color."] = true, 
	["Background Color"] = true, 
	["Set the bar background color."] = true, 
	["Background Alpha"] = true, 
	["Set the bar background alpha."] = true, 
	["Text Color"] = true, 
	["Set the bar text color."] = true, 
	["Text Size"] = true, 
	["Set the bar text size."] = true, 
	["Bar Scale"] = true, 
	["Set the bar scale."] = true, 
	["Bar Height"] = true, 
	["Set the bar height."] = true, 
	["Bar Width"] = true, 
	["Set the bar width."] = true, 
	["Bar Growth"] = true, 
	["Toggle the bar growing upwards or downwards."] = true, 
	["Reverse"] = true, 
	["Toggle the bar fill direction."] = true, 
	["Short Bar Text"] = true,
	["Enable short text for bars."] = true,
	["Enable Bars"] = true,
	["Enable timer bars."] = true,
	["Start Test Bars"] = true,
	["Start a few test bars."] = true,
	["Config"] = true, 
	["Show the GUI configuration menu."] = true, 
	["SmartRes"] = true,

	["You're not in a group."] = true,
	["No one in range to res."] = true,
	["Not enough mana to res."] = true,
	["Coudnt't find any dead (non-released) units."] = true,
	["All dead units are already being ressed."] = true,
	["Can't res while in combat."] = true,
	["Can't res right now."] = true,

	["Failed to res %s"] = true,
	["Ressing %s"] = true,
	["%s is resurrecting %s"] = true,
	["%s: %s"] = true,
	["^Corpse of (.+)$"] = true,
} end)

L:RegisterTranslations("zhCN", function() return {
	["Key Binding"] = "绑定按键",
	["Key Binding for resurrection."] = "为复活法术绑定一个按键",
	["Anchor"] = "锚点",
	["Show a dragable anchor."] = "显示一个可以拖动的锚点",
	["Resurrection Bars"] = "进度条",
	["Options for resurrection statusbar."] = "复活进度条的选项",
	["Bar Texture"] = "材质",
	["Change the texture of the timer bars."] = "改变复活进度条的材质", 
	["Bar Color"] = "颜色", 
	["Set the default bar color."] = "设置复活进度条的颜色", 
	["Background Color"] = "背景色", 
	["Set the bar background color."] = "设置复活进度条的背景颜色", 
	["Background Alpha"] = "背景透明度", 
	["Set the bar background alpha."] = "设置复活进度条的背景透明度", 
	["Text Color"] = "文字颜色", 
	["Set the bar text color."] = "设置复活进度条的文字颜色", 
	["Text Size"] = "文字大小", 
	["Set the bar text size."] = "设置复活进度条的文字大小", 
	["Bar Scale"] = "尺寸", 
	["Set the bar scale."] = "设置复活进度条的大小", 
	["Bar Height"] = "高度", 
	["Set the bar height."] = "设置复活进度条的高度", 
	["Bar Width"] = "宽度", 
	["Set the bar width."] = "设置复活进度条的宽度", 
	["Bar Growth"] = "向上排列", 
	["Toggle the bar growing upwards or downwards."] = "是否使复活状态条向上增长", 
	["Reverse"] = "反向填充", 
	["Toggle the bar fill direction."] = "是否使复活状态条向相反的方向填充", 
	["Short Bar Text"] = "使用缩略语",
	["Enable short text for bars."] = "在复活状态条上使用简短的文字",
	["Enable Bars"] = "启用状态条",
	["Enable timer bars."] = "是否启用复活状态条",
	["Start Test Bars"] = "测试",
	["Start a few test bars."] = "创建一些测试用的状态条",
	["Config"] = "选项", 
	["Show the GUI configuration menu."] = "显示选项", 
	--["SmartRes"] = "SmartRes",

	["You're not in a group."] = "你不在一个团队中",
	["No one in range to res."] = "范围内没有可以复活的玩家",
	["Not enough mana to res."] = "法力不足",
	["Coudnt't find any dead (non-released) units."] = "找不到可以复活的玩家",
	["All dead units are already being ressed."] = "所有玩家均已复活",
	["Can't res while in combat."] = "战斗中无法进行复活",
	["Can't res right now."] = "现在不能这么做",

	["Failed to res %s"] = "复活[%s]失败",
	["Ressing %s"] = "复活[%s]中",
	["%s is resurrecting %s"] = "[%s]正在复活[%s]",
	["%s: %s"] = "%s:%s",
	["^Corpse of (.+)$"] = "^([^%s]+)的尸体",
} end)

L:RegisterTranslations("deDE", function() return {
	["Key Binding"] = "Tastenbelegung",
	["Key Binding for resurrection."] = "Tastenbelegung f\195\188r Wiederbelebung.",
	["Anchor"] = "Anker",
	["Show a dragable anchor."] = "Einen verschiebbaren Anker anzeigen.",
	["Resurrection Bars"] = "Wiederbelebungsbalken",
	["Options for resurrection statusbar."] = "Optionen f\195\188r Wiederbelebungs-Statusbalken.",
	["Bar Texture"] = "Balkentextur",
	["Change the texture of the timer bars."] = "Die Textur der Balken \195\164ndern.", 
	["Bar Color"] = "Balkenfarbe", 
	["Set the default bar color."] = "Die Farbe der Balken festlegen.", 
	["Background Color"] = "Hintergrundfarbe", 
	["Set the bar background color."] = "Die Hintergrundfarbe der Balken festlegen.", 
	["Background Alpha"] = "Hintergrund Alpha", 
	["Set the bar background alpha."] = "Den Alphawert f\195\188r den Hintergrund festlegen.", 
	["Text Color"] = "Textfarbe", 
	["Set the bar text color."] = "Die Farbe des Textes auf den Balken festlegen.", 
	["Text Size"] = "Textgr\195\182\195\159e", 
	["Set the bar text size."] = "Die Gr\195\182\195\159e des Textes auf den Balken festlegen.", 
	["Bar Scale"] = "Balkenskalierung", 
	["Set the bar scale."] = "Die Skalierung der Balken festlegen.", 
	["Bar Height"] = "Balkenh\195\182he", 
	["Set the bar height."] = "Die H\195\182he der Balken festlegen.", 
	["Bar Width"] = "Balkenbreite", 
	["Set the bar width."] = "Die Breite der Balken festlegen.", 
	["Bar Growth"] = "Balkenanstieg", 
	["Toggle the bar growing upwards or downwards."] = "Legt fest ob die Balken nach oben oder nach unten wandern sollen.", 
	["Reverse"] = "Umkehren", 
	["Toggle the bar fill direction."] = "Legt fest in welche Richtung die Balken sich f\195\188llen sollen.", 
	["Short Bar Text"] = "Kurzer Balkentext",
	["Enable short text for bars."] = "Kurzen Text auf den Balken aktivieren.",
	["Enable Bars"] = "Balken aktivieren",
	["Enable timer bars."] = "Die Timer-Balken aktivieren.",
	["Start Test Bars"] = "Testbalken starten",
	["Start a few test bars."] = "Einige Testbalken starten.",
	["Config"] = "Konfig", 
	["Show the GUI configuration menu."] = "Das Konfigurationsmen\195\188 anzeigen.", 
	["SmartRes"] = "SmartRes",

	["You're not in a group."] = "Du bist in keiner Gruppe.",
	["No one in range to res."] = "Niemand in Reichweite zum Wiederbeleben.",
	["Not enough mana to res."] = "Nicht genug Mana zum Wiederbeleben.",
	["Coudnt't find any dead (non-released) units."] = "Keine toten (nicht freigegebene) Charaktere gefunden.",
	["All dead units are already being ressed."] = "Alle toten Charaktere werden bereits wiederbelebt.",
	["Can't res while in combat."] = "Kann nicht wiederbeleben wenn im Kampf.",
	["Can't res right now."] = "Kann jetzt nicht wiederbeleben.",

	["Failed to res %s"] = "Wiederbeleben auf %s fehlgeschlagen.",
	["Ressing %s"] = "Wirke Wiederbelebung auf %s",
	["%s is resurrecting %s"] = "%s belebt %s wieder",
	["%s: %s"] = "%s: %s",
	["^Corpse of (.+)$"] = "^Leiche von (.+)$",
} end)

L:RegisterTranslations("koKR", function() return {
	["^Corpse of (.+)$"] = "^([^%s]+)의 시체",
} end )

L:RegisterTranslations("zhTW", function() return {
	["^Corpse of (.+)$"] = "^(.+)的屍體",
} end )

L:RegisterTranslations("frFR", function() return {
	["^Corpse of (.+)$"] = "^Cadavre de (.+)$",
} end )

-- FuBarPlugin initilization
SmartRes.hasIcon = "Interface\\Icons\\Spell_Holy_Resurrection"  
SmartRes.defaultMinimapPosition = 180
SmartRes.cannotDetachTooltip = true
SmartRes.hasNoColor = true
SmartRes.clickableTooltip = true
SmartRes.hideWithoutStandby = true
SmartRes.independentProfile = true

function SmartRes:OnInitialize()
	-- Local lists
	self.ResTable = {}
	self.RessingTable = {}
	self.RessedTable = {}
	self.BlackListTable = {}
	self.Casting = nil
	self.Combat = false

	-- Additional colors
	P:RegisterColor("gray", 0.5, 0.5, 0.5)
	P:RegisterColor("forest", 0.0, 0.5, 0.0)
	P:RegisterColor("maroon", 0.5, 0.0, 0.0)
	P:RegisterColor("navy", 0.0, 0.0, 0.5)
	P:RegisterColor("olive", 0.5, 0.5, 0.0)
	P:RegisterColor("purple", 0.5, 0.0, 0.5)
	P:RegisterColor("teal", 0.0, 0.5, 0.5)

	local colors = {"white", "black", "blue", "magenta", "cyan", "green", "yellow",
			"orange", "red", "gray", "forest", "maroon", "navy", "olive",
			"purple", "teal"
	}

	-- Additional textures
	SM:Register("statusbar", "BantoBar", "Interface\\Addons\\SmartRes\\Textures\\banto")
	SM:Register("statusbar", "Smooth", "Interface\\Addons\\SmartRes\\Textures\\smooth")
	SM:Register("statusbar", "Perl", "Interface\\Addons\\SmartRes\\Textures\\perl")
	SM:Register("statusbar", "Glaze", "Interface\\Addons\\SmartRes\\Textures\\glaze")
	SM:Register("statusbar", "Cilo", "Interface\\Addons\\SmartRes\\Textures\\cilo")
	SM:Register("statusbar", "Charcoal", "Interface\\Addons\\SmartRes\\Textures\\Charcoal")

	-- Options taken from MendWatch
	local options = {
		type = 'group',
		args = {
			key = {
				name = L["Key Binding"],
				desc = L["Key Binding for resurrection."],
				order = 200,
				type = "text",
				validate = "keybinding",
				set = function(value)
					self:UnbindKey()
					self.db.profile.key = value
					self:BindKey()
				end,
				get = function()
					return self.db.profile.key
				end
			},
			anchor = {
				name = L["Anchor"],
				desc = L["Show a dragable anchor."],
				type = "execute",
				func = "ToggleAnchor"
			},
			bar = {
				name = L["Resurrection Bars"],
				desc = L["Options for resurrection statusbar."],
				type = "group",
				args = {
					texture = {
						name = L["Bar Texture"],
						desc = L["Change the texture of the timer bars."],
						type = "text",
						get = function () return self.db.profile.bartex end,
						set = function (v) self.db.profile.bartex = v end,
						validate = SM:List("statusbar"),
					},
					color = {
						name = L["Bar Color"],
						desc = L["Set the default bar color."],
						type = "text",
						get = function () return self.db.profile.barcolor end,
						set = function (v) self.db.profile.barcolor = v end,
						validate = colors,
					},
					bgcolor = {
						name = L["Background Color"],
						desc = L["Set the bar background color."],
						type = "text",
						get = function () return self.db.profile.bgcolor end,
						set = function (v) self.db.profile.bgcolor = v end,
						validate = colors,
					},
					bgalpha = {
						name = L["Background Alpha"],
						desc = L["Set the bar background alpha."],
						type = "range",
						get = function () return self.db.profile.bgalpha end,
						set = function (v) self.db.profile.bgalpha = v end,
						min = 0.0,
						max = 1.0,
					},
					textcolor = {
						name = L["Text Color"],
						desc = L["Set the bar text color."],
						type = "text",
						get = function () return self.db.profile.textcolor end,
						set = function (v) self.db.profile.textcolor = v end,
						validate = colors,
					},
					textsize = {
						name = L["Text Size"],
						desc = L["Set the bar text size."],
						type = "range",
						get = function () return self.db.profile.textsize end,
						set = function (v) self.db.profile.textsize = v end,
						min = 8,
						max = 20,
					},
					scale = {
						name = L["Bar Scale"],
						desc = L["Set the bar scale."],
						type = "range",
						get = function () return self.db.profile.barscale end,
						set = function (v) self.db.profile.barscale = v end,
						min = 0.5,
						max = 1.5,
					},
					height = {
						name = L["Bar Height"],
						desc = L["Set the bar height."],
						type = "range",
						get = function () return self.db.profile.barheight end,
						set = function (v) self.db.profile.barheight = v end,
						min = 8,
						max = 30,
					},
					width = {
						name = L["Bar Width"],
						desc = L["Set the bar width."],
						type = "range",
						get = function () return self.db.profile.barwidth end,
						set = function (v) self.db.profile.barwidth = v end,
						min = 50,
						max = 300,
					},
					growth = {
						name = L["Bar Growth"],
						desc = L["Toggle the bar growing upwards or downwards."],
						type = "toggle",
						get = function () return self.db.profile.growup end,
						set = function (v) self.db.profile.growup = v
							if v then
								self:SetCandyBarGroupPoint("SmartRes", "BOTTOM", self.anchor, "TOP", 0, 0)	
							else
								self:SetCandyBarGroupPoint("SmartRes", "TOP", self.anchor, "BOTTOM", 0, 0)	
							end
							self:SetCandyBarGroupGrowth("SmartRes", self.db.profile.growup)
						end,
					},
					reverse = {
						name = L["Reverse"],
						desc = L["Toggle the bar fill direction."],
						type = "toggle",
						get = function() return self.db.profile.reverse end,
						set = function(f) self.db.profile.reverse = f end,
					},
					text = {
						name = L["Short Bar Text"],
						desc = L["Enable short text for bars."],
						type = "toggle",
						get = function () return self.db.profile.shorttext end,
						set = function (v) self.db.profile.shorttext = v end,
					},
					enable = {
						name = L["Enable Bars"],
						desc = L["Enable timer bars."],
						order = -2,
						type = "toggle",
						get = function () return self.db.profile.enable end,
						set = function (v) self.db.profile.enable = v end,
					},
					test = {
						name = L["Start Test Bars"],
						desc = L["Start a few test bars."],
						order = -1,
						type = "execute",
						func = function()
							local text
							if  self.db.profile.shorttext then
								text = L["%s: %s"]
							else
								text = L["%s is resurrecting %s"]
							end
							self:CreateBar("smartresid1", 30, format(text, "Resser3", "Dead3"))
							self:CreateBar("smartresid2", 20, format(text, "Resser2", "Dead2"))
							self:CreateBar("smartresid3", 10, format(text, "Resser1", "Dead1"))
						end,
					}
				}
			}
		}
	}

	options.args.config = {
		name = L["Config"],
		desc = L["Show the GUI configuration menu."],
		type = "execute",
		guiHidden = true,
		func = function() DD:Open(UIParent, "children", function() DD:FeedAceOptionsTable(options) end, "cursorX", true, "cursorY", true) end,
	}

	-- FuBarPlugin
	self.OnMenuRequest = options

	local defaults = {
		key = "-",
		enable = true,
		bartex = "Smooth",
		barcolor = "green",
		bgcolor = "teal",
		bgalpha = 0.5,
		textcolor = "white",
		textsize = 11,
		barscale = nil,
		barwidth = 280,
		barheight = 15,
		growup = false,
		reverse = true,
		shorttext = false,
		barposition = {},
	}

	self:RegisterDB("SmartResDB")
	self:RegisterDefaults("profile", defaults)
	self:RegisterChatCommand({"/sr", "/smartres"}, options)

	-- Create the anchor frame
	self.anchor = self:CreateAnchor(L["SmartRes"], 0, 1, 0)

	-- Create candybar group
	self:RegisterCandyBarGroup("SmartRes")
	if self.db.profile.growup then
		self:SetCandyBarGroupPoint("SmartRes", "BOTTOM", self.anchor, "TOP", 0, 0)	
	else
		self:SetCandyBarGroupPoint("SmartRes", "TOP", self.anchor, "BOTTOM", 0, 0)	
	end
	self:SetCandyBarGroupGrowth("SmartRes", self.db.profile.growup)

	-- Prepare spells
	self.SpellIcons = {
		PRIEST = "Interface\\Icons\\Spell_Holy_Resurrection",
		SHAMAN = "Interface\\Icons\\Spell_Nature_Regenerate",
		PALADIN = "Interface\\Icons\\Spell_Holy_Resurrection"
	}
	self.Spell = BS[SmartResSpell[class]]

	-- Sucure button for casting spells
	self.button = CreateFrame("Button", "ResButton", UIParent, "SecureActionButtonTemplate")
        ResButton:SetAttribute("type", "spell")
        ResButton:SetScript("PreClick", function() self:Resurrect() end);

end

function SmartRes:OnEnable()
	self:BindKey()
	self:RegisterNoCombatEvents()
	self:RegisterCombatEvents()
end

function SmartRes:OnDisable()
	self:UnregisterAllEvents()
	self:UnbindKey()
end

function SmartRes:BindKey()
	SetOverrideBindingClick(self.button, false, self.db.profile.key, "ResButton")
end

function SmartRes:UnbindKey()
	ClearOverrideBindings(self.button)
end

function SmartRes:RegisterNoCombatEvents()
	self:RegisterBucketEvent("UNIT_HEALTH", 0.1)
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED")
	self:RegisterEvent("UNIT_SPELLCAST_STOP")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:HookScript(WorldFrame, "OnMouseDown", "WorldFrameOnMouseDown")
end

function SmartRes:RegisterCombatEvents()
        self:RegisterEvent("PLAYER_REGEN_DISABLED");
        self:RegisterEvent("PLAYER_REGEN_ENABLED");

	self:RegisterEvent("CHAT_MSG_ADDON")
	self:RegisterEvent("oRA_ResurrectionStart")
	self:RegisterEvent("oRA_ResurrectionStop")
	self:RegisterEvent("oRA_PlayerCanResurrect")
	self:RegisterEvent("oRA_PlayerResurrected")
	self:RegisterEvent("oRA_PlayerNotResurrected")
end

function SmartRes:UnregisterNoCombatEvents()
	self:UnregisterBucketEvent("UNIT_HEALTH")
	self:UnregisterEvent("UNIT_SPELLCAST_SENT")
	self:UnregisterEvent("UNIT_SPELLCAST_START")
	self:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	self:UnregisterEvent("UNIT_SPELLCAST_FAILED")
	self:UnregisterEvent("UNIT_SPELLCAST_STOP")
	self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:Unhook(WorldFrame, "OnMouseDown")
end

function SmartRes:UNIT_HEALTH(units)
	-- Used to track people being alive in case
	-- they die while still in RessedTable
	for unit in pairs(units) do
		dead = UnitIsDead(unit)
		if not dead and self.RessedTable[UnitName(unit)] then
			-- Reset tables for players who doesn't have ora2
			self.RessedTable[UnitName(unit)] = nil
			self.BlackListTable[UnitName(unit)] = nil
		end
	end
end

function SmartRes:PLAYER_REGEN_DISABLED()
	-- Unregister to avoid using resources while in combat
	self:UnregisterNoCombatEvents()
	self.Combat = true
end

function SmartRes:PLAYER_REGEN_ENABLED()
	-- Register again after combat
	self:RegisterNoCombatEvents()
	self.Combat = false

	-- Check for spells being cast since we don't listen in combat
	self.Casting = true and UnitCastingInfo("player")
end

function SmartRes:UNIT_SPELLCAST_START(unit)
	if not UnitIsUnit(unit, "player") then
		local _, englishClass = UnitClass(unit);
		local name, nameSubtext, text, texture, startTime, endTime, isTradeSkill = UnitCastingInfo(unit)
		if SmartResSpell[englishClass] == name then
			local unittarget = unit .. "target"
			if UnitExists(unittarget) and UnitIsDead(unittarget) then
				self.BlackListTable[UnitName(unittarget)] = 25
			end
		end
	end
end

function SmartRes:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
	if UnitIsUnit(unit, "player") then
		self.Casting = true
		if spell == self.Spell then
			if not target or target == "" then
				target = self.MouseDownTarget
			end
			local targetcolored = self:ClassTextColor(target, select(2, UnitClass(target)))
			self:Print(format(L["Ressing %s"], targetcolored))
			self.Target = target
		else
			self.Target = nil
		end
	end
end

-- Fix for UNIT_SPELLCAST_SENT target being empty (from oRA2)
function SmartRes:WorldFrameOnMouseDown()
	if GameTooltipTextLeft1:IsVisible() then
		local target = select(3, GameTooltipTextLeft1:GetText():find(L["^Corpse of (.+)$"]))
		if target then
			self.MouseDownTarget = target
		end
	end
	self.hooks[WorldFrame]["OnMouseDown"]()
end

function SmartRes:UNIT_SPELLCAST_INTERRUPTED(unit)
	if UnitIsUnit(unit, "player") and self.Target then
		self.BlackListTable[self.Target] = (self.BlackListTable[self.Target] or 0) + 10
		self.Target = nil
	end
end

function SmartRes:UNIT_SPELLCAST_FAILED(unit)
	--self:Print("UNIT_SPELLCAST_FAILED")
	if UnitIsUnit(unit, "player") and self.Target then
		self:Print(format(L["Failed to res %s"], self.Target))
		self.BlackListTable[self.Target] = 25
		self.Target = nil
		self.Casting = nil
	end
end

function SmartRes:UNIT_SPELLCAST_STOP(unit)
	--self:Print("UNIT_SPELLCAST_STOP")
	if UnitIsUnit(unit, "player") then
		self.Casting = nil
	end
end

function SmartRes:UNIT_SPELLCAST_SUCCEEDED(unit, spell, rank)
	if UnitIsUnit(unit, "player") and spell == self.Spell and self.Target then
		self.RessedTable[self.Target] = GetTime()
		self.BlackListTable[self.Target] = nil
		SendAddonMessage("SmartRes", "RESSED " .. self.Target, "RAID")
	end
end

function SmartRes:CHAT_MSG_ADDON(prefix, msg, type, author)
	if type ~= "RAID" then return end
	if prefix ~= "SmartRes" then return end
	local player = select(3, msg:find("RESSED (.+)$"))
	if player and not self.RessedTable[player] then
		self.RessedTable[player] = GetTime()
		self.BlackListTable[player] = nil
	end
end

function SmartRes:oRA_ResurrectionStart(msg, author)
	local player = select(3, msg:find("^RES (.+)$"))
	if player and author then
		self.RessingTable[author] = player

		if not self.Combat then
			local text
			if self.db.profile.shorttext then
				text = L["%s: %s"]
			else
				text = L["%s is resurrecting %s"]
			end
			local authorcolored = self:ClassTextColor(author, select(2, UnitClass(author)))
			local playercolored = self:ClassTextColor(player, select(2, UnitClass(player)))
			self:CreateBar(author, 10, format(text, authorcolored, playercolored), author)
		end
	end
end

function SmartRes:oRA_ResurrectionStop(msg, author)
	if author and self.RessingTable[author] then
		self.RessingTable[author] = nil

		self:StopCandyBar(author)
	end
end

function SmartRes:oRA_PlayerCanResurrect(msg, author)

end

function SmartRes:oRA_PlayerResurrected(msg, author)
	if author and not self.RessedTable[author] then
		self.RessedTable[author] = GetTime()
		self.BlackListTable[author] = nil
	end
end

function SmartRes:oRA_PlayerNotResurrected(msg, author)
	-- Note also triggered resurrect is accepted
	if author and self.RessedTable[author] then
		-- Add 2 sec delay where player is still flagged as ressed
		-- to account for time between resurrect dialog is closed
		-- and the player is actually alive
		self.RessedTable[author] = GetTime() - 58
		--self.RessedTable[author] = nil
	end
end

function SmartRes:CreateBar(id, time, text, iconunit)
	if self.db.profile.enable then
		local barclass
		if UnitExists(iconunit) then barclass = select(2, UnitClass(iconunit)) else barclass = class end
		local texture = self.SpellIcons[barclass]
		self:RegisterCandyBar(id, time, text, texture, self.db.profile.barcolor)
		if self.db.profile.bartex then self:SetCandyBarTexture(id, SM:Fetch('statusbar', self.db.profile.bartex)) end
		if self.db.profile.bgcolor then self:SetCandyBarBackgroundColor(id, self.db.profile.bgcolor, self.db.profile.bgalpha) end
		if self.db.profile.textcolor then self:SetCandyBarTextColor(id, self.db.profile.textcolor) end
		if self.db.profile.textsize then self:SetCandyBarFontSize(id, self.db.profile.textsize) end
		if self.db.profile.barscale then self:SetCandyBarScale(id, self.db.profile.barscale) end
		if self.db.profile.barwidth then self:SetCandyBarWidth(id, self.db.profile.barwidth) end
		if self.db.profile.barheight then self:SetCandyBarHeight(id, self.db.profile.barheight) end
		self:SetCandyBarReversed(id, self.db.profile.reverse)
		self:SetCandyBarFade(id, 0.5, true)
		self:RegisterCandyBarWithGroup(id, "SmartRes")
		self:StartCandyBar(id, true)
	end
end

function SmartRes:Debug(text)
	--self:Print("|cff0099CCDebug - "..text.."|r")
end

function SmartRes:Resurrect()
	ResButton:SetAttribute("unit", nil)
        ResButton:SetAttribute("spell", nil)
	
	if self.Casting then return	end
	if GetNumPartyMembers() == 0 then
		self:Print(L["You're not in a group."])
		return
	end

	local usable, nomana = IsUsableSpell(self.Spell)
	if not usable then
		if nomana then
			self:Print(L["Not enough mana to res."])
		else
			if UnitAffectingCombat("player") then
				self:Print(L["Can't res while in combat."])
			else
				self:Print(L["Can't res right now."])
			end
		end
		return
	end

	self.ResTable = {}
	if UnitInRaid("player") then
		self:Debug("Building Raid ResTable")
		self:BuildResTable("raid")
	else
		self:Debug("Building Party ResTable")
		self:BuildResTable("party")
	end
	if self.NumCorpses == 0 then
		self:Print(L["Coudnt't find any dead (non-released) units."])
		return
	end
	if self.NumCorpses - self.NumCorpsesRessed == 0 then
		self:Print(L["All dead units are already being ressed."])
		return
	end
	table.sort(
		self.ResTable, 
		function(val1, val2)
			return val1[2] < val2[2]
		end
	)

	self.corpse = self:ChooseDeadUnitInRange()
	if self.corpse then
	        ResButton:SetAttribute("unit", self.corpse)
	        ResButton:SetAttribute("spell", self.Spell)
		--self.RessedTable[UnitName(self.corpse)] = GetTime()
	else
		self:Print(L["No one in range to res."])
	end
end

function SmartRes:BuildResTable(type)
	local x
	if type == "raid" then x = GetNumRaidMembers()
	elseif type == "party" then x = GetNumPartyMembers()
	end
	self.NumCorpses = 0
	self.NumCorpsesRessed = 0
	for i = 1, x do
		if UnitIsConnected(type..i) then
			if UnitIsDead(type..i) then
				self.NumCorpses = self.NumCorpses + 1
				if not self:UnitDoesntNeedRes(UnitName(type..i)) then
					tinsert(self.ResTable, { type..i, self:GetResModifier(type..i) })
				else
					self.NumCorpsesRessed = self.NumCorpsesRessed + 1
				end
			else
				local name = UnitName(type..i)
				if self.RessedTable[name] then
					self.RessedTable[name] = nil
				end
				if self.BlackListTable[name] then
					self.BlackListTable[name] = nil
				end

			end
		end
	end
end

function SmartRes:GetResModifier(unit)
	local name = UnitName(unit)
	local m = 0
	local _,englishClass = UnitClass(unit)
	if englishClass == "PRIEST" then m = 0
	elseif englishClass == "SHAMAN" then m = 5
	elseif englishClass == "PALADIN" then m = 5
	elseif englishClass == "DRUID" then m = 10
	elseif englishClass == "MAGE" then m = 10
	elseif englishClass == "WARLOCK" then m = 15
	elseif englishClass == "HUNTER" then m = 15
	elseif englishClass == "WARRIOR" then m = 20
	elseif englishClass == "ROGUE" then m = 20
	end
	if UnitInParty(unit) then m = m - 1 end
	-- we don't want to get stuck on someone out of LOS
	m = m + math.random(5)
	if self.BlackListTable[UnitName(unit)] then
		m = m + self.BlackListTable[UnitName(unit)]
	end
	if UnitIsAFK(unit) then
		m = m + 10
	end
	if UnitIsUnit(unit, "target") then
		m = m - 25
	end
	return m
end

function SmartRes:UnitDoesntNeedRes(name)
	-- check who we attempted to res in the past minute:
	if self.RessedTable[name] then
		if GetTime() - self.RessedTable[name] < 60 then -- and name ~= UnitName("target")
			self:Debug("Skipping "..name.." - Recently Ressed")
			return true
		end
	end

	for author, player in pairs(self.RessingTable) do
		if name == player then
			self:Debug("Skipping " .. player .. " since he is being ressed by " .. author)
			return true
		end
	end

	return false
end

function SmartRes:ChooseDeadUnitInRange()
	for key, val in ipairs(self.ResTable) do
		self:Debug("Testing Range for: "..UnitName(val[1]))
		if IsSpellInRange(self.Spell, val[1]) == 1 then
			return val[1]
		end
	end
	return nil
end

function SmartRes:GetTexture(name)
	local i = 1
	while true do
		local nm = GetSpellName(i, BOOKTYPE_SPELL)
		if not nm then break
		elseif nm == name then
			tx = GetSpellTexture(i, BOOKTYPE_SPELL)
			return tx
		end
		i = i + 1
	end
end

function SmartRes:ToggleAnchor()
	if self.anchor:IsVisible() then
		self.anchor:Hide()
	else
		self.anchor:Show()
	end
end

-- CreateAnchor taken from MendWatch
function SmartRes:CreateAnchor(text, cRed, cGreen, cBlue)
	local f = CreateFrame("Button", nil, UIParent)
	f:SetWidth(200)
	f:SetHeight(25)

	f.owner = self

	if self.db.profile.barposition.x and self.db.profile.barposition.y then
		f:ClearAllPoints()
		f:SetPoint("TOPLEFT", UIParent, "TOPLEFT", self.db.profile.barposition.x, self.db.profile.barposition.y)
	else
		f:SetPoint("CENTER", UIParent, "CENTER", 0, 50)
	end

	f:SetScript("OnDragStart", function() this:StartMoving() end )
	f:SetScript("OnDragStop",
		function()
			this:StopMovingOrSizing()
			local _, _, _, x, y = this:GetPoint()
			this.owner.db.profile.barposition.x = math.floor(x)
			this.owner.db.profile.barposition.y = math.floor(y)
		end)

	f:SetBackdrop({
		--bgFile = "Interface/Tooltips/UI-Tooltip-Background",
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
		tile = false, tileSize = 16, edgeSize = 16,
		insets = {left = 5, right = 5, top = 5, bottom = 5}
	})
	f:SetBackdropColor(cRed, cGreen, cBlue, .6)
	f:SetMovable(true)
	f:RegisterForDrag("LeftButton")

	f.Text = f:CreateFontString(nil, "OVERLAY")
	f.Text:SetFontObject(GameFontNormalSmall)
	f.Text:ClearAllPoints()
	f.Text:SetTextColor(1, 1, 1, 1)
	f.Text:SetWidth(200)
	f.Text:SetHeight(25)
	f.Text:SetPoint("TOPLEFT", f, "TOPLEFT")
	f.Text:SetJustifyH("CENTER")
	f.Text:SetJustifyV("MIDDLE")
	f.Text:SetText(text)

	f:Hide()

	return f
end

function SmartRes:ClassTextColor(text, class)
	return format("|cff%s%s|r", P:GetHex(class), text)
end